const express = require('express');
const path = require('path');

const app = express();
app.use(express.static(path.join(__dirname, 'public')));
 

const paginaPrincipalController = function(req, res, next) {
	res.send("<h1>Página Principal</h1>");
}


const rutaController = (req,res, next) => {
	var numerodelaruta = req.params.numerodelaruta;
	res.send("<h1>Número de la ruta: "+numerodelaruta +"</h1><img src='/"+numerodelaruta+".jpg'/>")
}

const rutasController = (req, res, next) => {
	let template = "<h1>Rutas disponibles</h1><ul>"
	for (let i = 1; i < 31; i++) {
		template += "<li><a href='/ruta/"+i+"'>Ruta" + i + "</a></li>"
	}
	template +="</ul>"
	res.send(template)
}

app.get('/', paginaPrincipalController);
app.get('/ruta/:numerodelaruta([0-9]+)',rutaController);
app.get('/rutas',rutasController);

app.listen(8000);